<?Php
/*
  $Id: ebullion.php,v 0.1 2004/03/20

  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Adapted from the emocorp source under GPL

  Copyright (c) 2004 rayServers.com

  Laptops, Workstations & Servers that are Installed Secure
  http://www.rayservers.com/

  Revision December 2007 - BullionFever.com
  Gold and Silver Coins, Ingots, Bars, Bullion

  Released under the GNU General Public License
  Version 0.1

*/


  class ebullion {
    var $code, $title, $description, $enabled;

// class constructor
    function ebullion() {
      $this->code = 'ebullion';
      $this->title = MODULE_PAYMENT_EBULLION_TEXT_TITLE;
      $this->description = MODULE_PAYMENT_EBULLION_TEXT_DESCRIPTION;
      $this->sort_order = MODULE_PAYMENT_EBULLION_SORT_ORDER;
      $this->enabled = ((MODULE_PAYMENT_EBULLION_STATUS == 'True') ? true : false);

      if ((int)MODULE_PAYMENT_EBULLION_ORDER_STATUS_ID > 0) {
        $this->order_status = MODULE_PAYMENT_EBULLION_ORDER_STATUS_ID;
      }
      $this->form_action_url = 'https://atip.e-bullion.com/process.php';
    }

// class methods
    function javascript_validation() {
      return false;
    }

    function selection() {
      return array('id' => $this->code,
                   'module' => $this->title);
    }

    function pre_confirmation_check() {
      return false;
    }

    function confirmation() {
      return false;
    }

    function process_button() {
      global $order, $currencies;
      
      $process_button_string = tep_draw_hidden_field('ATIP_STATUS_URL', '') .
			       tep_draw_hidden_field('ATIP_STATUS_URL_METHOD', 'POST') .
			       tep_draw_hidden_field('ATIP_BAGGAGE_FIELDS', '') .
			       tep_draw_hidden_field('ATIP_SUGGESTED_MEMO', '') .
			       tep_draw_hidden_field('ATIP_FORCED_PAYER_ACCOUNT', '') .
			       tep_draw_hidden_field('ATIP_PAYER_FEE_AMOUNT', '') .
                               tep_draw_hidden_field('ATIP_PAYMENT_URL', tep_href_link(FILENAME_CHECKOUT_PROCESS, '', 'SSL')) .
			       tep_draw_hidden_field('ATIP_PAYMENT_URL_METHOD', 'POST') .
			       tep_draw_hidden_field('ATIP_NOPAYMENT_URL', tep_href_link(FILENAME_CHECKOUT_PAYMENT, '', 'SSL')) .
			       tep_draw_hidden_field('ATIP_NOPAYMENT_URL_METHOD', 'POST') .
			       tep_draw_hidden_field('ATIP_PAYMENT_FIXED', '0') .
                               tep_draw_hidden_field('ATIP_PAYMENT_AMOUNT', number_format($order->info['total'] * $currencies->currencies['USD']['value'], $currencies->currencies['USD']['decimal_places'], '.', '')) .
			       tep_draw_hidden_field('ATIP_PAYMENT_UNIT', '1') .
			       tep_draw_hidden_field('ATIP_PAYMENT_METAL', '0') .
	                       tep_draw_hidden_field('ATIP_PAYEE_ACCOUNT', MODULE_PAYMENT_EBULLION_ACCOUNT_NUMBER) .
                               tep_draw_hidden_field('ATIP_PAYEE_NAME', MODULE_PAYMENT_EBULLION_ACCOUNT_NAME) .
	                       tep_draw_hidden_field('ATIP_PAYEE_NAME', MODULE_PAYMENT_EBULLION_ACCOUNT_NAME) .
			       tep_draw_hidden_field('ATIP_PAYER_FEE_AMOUNT', ''); 

      return $process_button_string;
    }

    function before_process() {
	return false;
    }

    function after_process() {
      return false;
    }

    function output_error() {
      return false;
    }

    function check() {
      if (!isset($this->_check)) {
        $check_query = tep_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_EBULLION_STATUS'");
        $this->_check = tep_db_num_rows($check_query);
      }
      return $this->_check;
    }

    function install() {
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Enable E-Bullion Module', 'MODULE_PAYMENT_EBULLION_STATUS', 'True', 'Do you want to accept ebullion payments?', '6', '3', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort order of display.', 'MODULE_PAYMENT_EBULLION_SORT_ORDER', '0', 'Sort order of display. Lowest is displayed first.', '6', '0', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('ebullion Account Number', 'MODULE_PAYMENT_EBULLION_ACCOUNT_NUMBER', 'B99999', 'Your ebullion account number to which the payment is to be made.', '6', '4', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('ebullion Account Name', 'MODULE_PAYMENT_EBULLION_ACCOUNT_NAME', 'Account Name', 'Your ebullion account name to which the payment is to be made.', '6', '4', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('Set Order Status', 'MODULE_PAYMENT_EBULLION_ORDER_STATUS_ID', '0', 'Set the status of orders made with this payment module to this value', '6', '0', 'tep_cfg_pull_down_order_statuses(', 'tep_get_order_status_name', now())");
    }

    function remove() {
      tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }

    function keys() {
      return array('MODULE_PAYMENT_EBULLION_STATUS', 'MODULE_PAYMENT_EBULLION_SORT_ORDER', 'MODULE_PAYMENT_EBULLION_ACCOUNT_NUMBER', 'MODULE_PAYMENT_EBULLION_ACCOUNT_NAME', 'MODULE_PAYMENT_EBULLION_ORDER_STATUS_ID');
    }
  }
?>
